package be.ac.umons.ProjetInfo.BAC1.CharlierDucruet;

import java.awt.geom.Point2D;
public abstract class Config
{
    
    /* taille de la fenetre et de la zone de jeu */
    private static final int DEFAULTSIZEX = 900, DEFAULTSIZEY= 720; // taille par defaut de l'cran permet de calculer le ratio
    private static int frameX = 900, frameY = 720; // taille rel de la zone de jeu.
    private static double tRefresh = 16; //temps entre chaque refresh de l'espace de jeu (1/60s)
    private static final Point2D.Double PCENTER = new Point2D.Double(900/2, 720/2); // point central de la fentre
    private static double frameRate = 1; // rapport de reduction de la fentre
    private static Point2D.Double mousseRate = new Point2D.Double(1,1); // rapport d'agrandissement de la fentre.
    private static final double FRAMEDIAGONAL = Math.sqrt(DEFAULTSIZEX * DEFAULTSIZEX + DEFAULTSIZEY * DEFAULTSIZEY); // taille de la diagonal de l'cran par defaut
    private static final double FRAMEPRINTMOBILE = FRAMEDIAGONAL * 0.315; // distance  partir de la quel les mobiles sont affich dans la zone de jeu
    private static final double FRAMEDRAWMOBILE = FRAMEDIAGONAL * 0.280; // distance  la quel on dessine les mobile autour de la zone de jeu
    private static final double FRAMEDISTANCEMAXMOBILE = FRAMEDIAGONAL * 2; // distance  la quel on dessine les mobile autour de la zone de jeu
    
    
    private static int currentDifficulti = 1; // diffcult 0 facile, 1 moyenne , 2 difficile

    
    /* constantes et coefficients en fonction des niveaux */
    private static final double[] DifficultiSpeed = {0.80, 1, 1.20}; // facteur de vitesse des mobiles
    private static final int[] DifficultiScoreFactor = {1, 2, 3};  //facteur pour le score > plus on est en haute difficult plus on gagne de point
    private static final int[] DifficultiMovingAddAngle = {45, 30, 15}; // angle d'ajout des mobiles

    /* Vaisseau */
    public static final int SpaceShipAngleTurn = 180; // angle par seconde avec le quel on tourne
    /* Missile*/
    
    private static final int[] DifficultiTempMLIncreaseRate = {13, 15, 20}; // temprature gagne par tir
    private static final int[] DifficultiMissileTimeInterFire = {150, 170, 200}; // temps entre les tir de missile en rafale.

    
    // asteroides

    private static final double[] DifficultiCollLife = {28, 33.33, 37}; // vie perdue en cas de collision avec un asteroides.
    private static final int[] DifficultiAsteroidRadiusMin = {15, 15, 15}; // rayon minimum des asteroides
    private static final double[] DifficultiAsteroidRadiusDivFactor = {1.3, 1.3, 1.3}; // facteur de division des asteroides
    private static final int[] DifficultiAsteroidNb = {60, 70, 80}; // nombre d'asteroides dans la partie.
    
    // bonus
    private static final int[] DifficultiBonusLife = {30, 20, 20}; // nombre de pv rendue par niveau de diffcult
    private static final double[] DifficultiBonusFactor = {1D/10, 1D/15, 1D/20}; // facteur d'apparition des bonus.
    private static final int[] DifficultiBonusInvulnerableTime = {15, 11, 8}; // temps d'invulnerabilit. (en seconde)
    private static final int[] DifficultiBonusSpeed = {15, 20, 25}; // temps d'invulnerabilit. (en seconde)
    private static final int[] DifficultiBonusRadar = {6000, 4000, 3000};// temps d'amelioration radar
    private static final int[] DifficultiMalusRadar = {6000, 8000, 12000};// temps de pause du radar
    private static final int[] DifficultiBonusTime = {30000, 15000, 10000};// temps d'amlioration du radar
    
    // astraunote  sauver
    private static final int SpaceManNbInit = 5; // nombre d'astronaute  sauver
    private static final int SpaceManLvlAdd = 1; // nombre d'astraunote en plus par niveaux
    private static final int SpaceManLvlTimeInit = 90000; // nombre de milisecondes pour attraper les astraunotes au niveau 0
    private static final int SpaceManLvlTimeBonus = 30000; // le nombre de seconde qu'on peut avoir en plus par niveau par apport au lvl 0
    private static final int[] SpaceManDifficultiRadius = {35, 32, 30}; // le rayon des astraunotes en fct du niveau de difficult.
    private static final int[] SpaceManDifficultiTimeCapture = {3000, 4000, 4500}; // le temps pour capturer un astronaute
    
    
    /* Accsseur relatif  la fentre */
    
    
    /**
    * Modifie la taille de la zone de jeu.
    * @param x la largeur de la zone.
    * @param y la hauteur de la zone.
    */
    public static void setFrame(int x, int y)
    {
        frameX = x;
        frameY = y;
        frameRate = ((double) (x) )/ DEFAULTSIZEX ; // on calcule un ratio pour afficher correctement les affaires.
        mousseRate = new Point2D.Double((double) (DEFAULTSIZEX) / x, (double) (DEFAULTSIZEY) / y);
    }
    
    /**
    * @return la position du point centrale de la fenetre
    */
    public static Point2D.Double getPCenter()
    {
        return PCENTER;
    }
    
    /**
    * @return la hauteur de la fentre.
    */
    public static int getFrameX()
    {
        return DEFAULTSIZEX;
    } 

    /**
    * @return la largeur de la fentre.
    */    
    public static int getFrameY()
    {
        return DEFAULTSIZEY;
    }
    
    /**
    * Modifie le temps de refresh.
    * @param t nouveau temps de refresh.
    */
    public static void setRefresh(double t)
    {
        tRefresh = t;
    }
    
    /**
    * @return le temps de rafraichissement de la zone de jeu
    */
    public static double getRefresh()
    {
        return tRefresh;
    }
    
    /**
    * @return la distance  partir de la quelle les mobiles sont visible dans la zone de jeu
    */
    public static double getDistancePrintMobile()
    {
        return FRAMEPRINTMOBILE;
    }
    
    /**
    * @return la distance  la quelle ont dessine les mobiles autours de la zone de jeu
    */
    public static double getDistanceDrawMobile()
    {
        return FRAMEDRAWMOBILE;
    }
        
    /**
    * @return la distance max qu'un mobile peut avoir avec le vaisseau
    */
    public static double getDistanceMaxShip()
    {
        return FRAMEDISTANCEMAXMOBILE;
    }
        
    /**
    * @return la longeur de la diagonal de la fenetre de jeu (par defaut)
    */
    public static double getDiagonalFrame()
    {
        return FRAMEDIAGONAL;
    }
    
    /**
    *   @return Le ratio dont la fenetre est reduite
    */
    public static double getFrameRate()
    {
        return frameRate;
    }
    
    /**
    *   @return Un point reprsentant la rduction de la fentre en x et y;
    */
    public static Point2D.Double getMousseRate()
    {
        return mousseRate;
    }
    
    
    /* Accesseurs relatif aux niveaux */
    
    
    /**
    * @return le niveau de difficult  courant dans le jeu.
    */
    public static int getDifficulti()
    {
        return currentDifficulti;
    }    

    /**
    * @return le niveau de difficult  courant dans le jeu sous forme de texte.
    */
    public static String getDifficultiString()
    {
        if (currentDifficulti == 0)
            return "facile";
        else if (currentDifficulti == 1)
            return "moyenne";
        else
            return "difficile";
    } 
    
    /**
    * Modifie le niveau actuel de difficult
    * @param l un niveau.
    */
    public static void setDifficulti(int l)
    {
        if (l < 0)
            currentDifficulti = 0;
        else if (l > 2)
            currentDifficulti = 2;
        else
            currentDifficulti = l;
    }
        
    /**
    * @return le facteur de score.
    * Plus on est en difficult  faible moins on gagne de point.
    * Est utilis pour le scoring du bonus temps en fin de partie.
    */
    public static int getScoreFactor()
    {
        return DifficultiScoreFactor[currentDifficulti];
    }
    
    /**
    * @return le facteur de vitesse en fonction du niveau actuel.
    */
    public static double getCurrentSpeedFactor()
    {
        return DifficultiSpeed[currentDifficulti];
    }
            
    /**
    *   @return L'angle d'ajout des asteroides
    */
    public static int getMovingAddAngle()
    {
        return DifficultiMovingAddAngle[currentDifficulti];
    }
    
    /* Accesseur relatif au Asterodes */
    
    
    /**
    * @return le rayon minimal des astrodes en fonction du niveau actuel.
    */
    public static int getCurrentAsteroidRadiusMin()
    {
        return DifficultiAsteroidRadiusMin[currentDifficulti];
    }
    
    /**
    * @return le facteur de rduction de rayon en fonction du niveau actuel.
    */
    public static double getCurrentAsteroidRadiusDivFactor()
    {
        return DifficultiAsteroidRadiusDivFactor[currentDifficulti];
    } 
    
    /**
    *   @return Facteur d'apparition des bonus.
    *   Facteur d'apparition des bonus.<br /> Plus la difficult est faible, plus on a de chance d'avoir un bonus qui apparait.
    */
    public static double getBonusFactor()
    {
        return DifficultiBonusFactor[currentDifficulti];
    }
        
    /**
    * @return le nombre d'asteroides minimum voulu dans une partie.
    */
    public static double getAsteroidNb()
    {
        return DifficultiAsteroidNb[currentDifficulti];
    }

        
    /**
    * @return La vie max perdue en cas de collision.
    */
    public static double getCollLife()
    {
        return DifficultiCollLife[currentDifficulti];
    } 
    
    /* Accesseurs relatif au vaisseau */
    
    /**
    * @return L'angle de rotation pour le vaisseau et la tour de tir par tic
    * Max SpaceShipAngleTurn degrs / seconde.
    */
    public static double getTurnFactor()
    {
        return  (SpaceShipAngleTurn * (tRefresh / 1000));
    }
    

    /* Accesseurs relatif au bonus */ 
    
    /**
    * @return le nombre de vies rendu par un bonus vie en fonction du niveau
    */
    public static int getBonusLife()
    {
        return DifficultiBonusLife[currentDifficulti];
    }  
    
    /**
    *   @return Le temps d'invulnrabilit donn par un bonus en fonction du niveau.
    */
    public static int getInvulnerableTime()
    {
        return DifficultiBonusInvulnerableTime[currentDifficulti] * 1000;
    }   
    
    /**
    *   @return la vitesse d'un bonus en fonction du niveau.
    */
    public static int getBonusSpeed()
    {
        return DifficultiBonusSpeed[currentDifficulti];
    }

    
    /* Accesseurs relatif aux missile */
  
  
    /**
    *   @return le temps minimum entre chaque tir en fonction du niveau.
    */
    public static int getMissileTimeInterFire()
    {
        return DifficultiMissileTimeInterFire[currentDifficulti];
    }   
    
    /**
    *   @return le nombre de missiles maximum dans la fentre.
    */
    public static int getTempMLIncreaseRate()
    {
        return DifficultiTempMLIncreaseRate[currentDifficulti];
    } 
    
    /* Accesseur relatif aux astraunautes */
    
    /**
    * @return le nombre d'astraunaute  sauver en debut de partie
    */
    public static int getSpaceManInit()
    {
        return SpaceManNbInit;
    }    
    
    /**
    * @return le nombre d'astraunaute  sauver en plus par niveaux.
    */
    public static int getSpaceManLvlAdd()
    {
        return SpaceManLvlAdd;
    }    
    
    /**
    * @return Le temps rserv  la recherche des astraunaute au niveau de dpart
    */
    public static int getSpaceManLvlTimeInt()
    {
        return SpaceManLvlTimeInit;
    } 
    
    /**
    * @return Le temps bonus niveau rserv  la recherche des astraunaute au niveau de dpart
    */
    public static int getSpaceManLvlTimeBonus()
    {
        return SpaceManLvlTimeBonus;
    }      
    
    /**
    * @return Le rayon des astraunautes.
    */
    public static int getSpaceManRadius()
    {
        return SpaceManDifficultiRadius[currentDifficulti];
    }  
    
    /**
    * @return Le temps nesscaire  la capture d'un astronaute.
    */
    public static int getSpaceManTimeCapture()
    {
        return SpaceManDifficultiTimeCapture[currentDifficulti];
    }    
    
    /**
    * @return le facteur de temps pendant lequel le radar est ameliorer
    */
    public static double getDifficultiBonusRadar()
    {
        return DifficultiBonusRadar[currentDifficulti];
    }
    /**
    * @return le facteur de temps pendant lequel le radar est en pause
    */
    public static double getDifficultiMalusRadar()
    {
        return DifficultiMalusRadar[currentDifficulti];
    }
  
    /**
    * @return le facteur pour le bonus temps
    */
    public static double getDifficultiBonusTime()
    {
        return DifficultiBonusTime[currentDifficulti];
    }
}
