package be.ac.umons.ProjetInfo.BAC1.CharlierDucruet;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.gui.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.geom.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.game.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.listener.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.*;

import java.awt.Graphics;
import java.awt.Color;
import java.awt.geom.Point2D;
import java.util.ArrayList;
import java.util.Timer;
import java.util.TimerTask;
public class Main
{
    private static Display display;
    private static Engine game;
    
    /* On mets les timers en variable de classe pour les utiliser dans les sous classes */
    private static Timer tClockGame, tClockRepaint;
    
    private static long tRepaint = 33L; //valeur par defaut du repaint : 33 IPS
    private static TimerTask frameRefresh; //pour pouvoir le modifier via le menu, on le mets en static
    
    public static void main(String[] args)
    {
        display = new Display();
        
        // Affichage tant que la touche 'x' n'est pas appuyée
        /* Time pour le jeu */
        tClockGame = new Timer(); //on initialise le Timer
        TimerTask gameRefresh = new TimerTask()
        {
            public void run ()
            {      
                if(!Engine.isGameOver() && !Engine.isBreackGame()) 
                {
                    /* Si le jeu est lancé et qu'on est pas en pause, on le mets à jours */
                    game.go(); 
                }
                
                if (Key.isKeyEscPressed()) // si on appuie sur X
                {
                    // Fermeture de la fenêtre.
                    display.close(); 
                    // on arrête les timer
                    tClockGame.cancel();
                    tClockRepaint.cancel();
                }
            }
        }; 
        // lance le Timer
        tClockGame.schedule(gameRefresh, 0, (long) Config.getRefresh()); 
        
        /* Timer du refresh de l'affichage */
        tClockRepaint = new Timer();
        initFrameRefresh();
        tClockRepaint.schedule(frameRefresh, 0, tRepaint); 
    }
    
    /**
    * @return l'environnement graphique
    */
    public static Display getDisplay()
    {
        return display;
    }
    
    /**
    * @return le jeu (l'Engine).
    */
    public static Engine getGame()
    {
        return game;
    }
    
    /**
    * Modifie le jeu.
    */
    public static void setGame(Engine g)
    {
        game = g;
    }    
    
    /**
    * Modifie le temps entre les repaints.
    */
    public static void setTRepaint(long t)
    {
        if (t != tRepaint) // on évite de change le timer si il est déjà "bien réglé"
        {
            tRepaint =t;
            frameRefresh.cancel(); // on supprime le timerTask
            initFrameRefresh(); // on l'initialise
            tClockRepaint.schedule(frameRefresh, 0, tRepaint); 
        }
    }
    
    /**
    * Initialise le timerTask permettant de faire le repaint.
    */
    public static void initFrameRefresh()
    {
        frameRefresh = new TimerTask()
        {
            public void run ()
            {      
                display.validate();
                display.repaint(); // actualise l'affichage
            }
        };    
    }
    

}
