package be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.game;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.listener.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.geom.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.gui.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.*;

import java.awt.geom.Point2D;
import java.util.Random;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Font;
import java.awt.geom.AffineTransform;
import java.awt.Image;
import java.awt.Graphics2D;
import java.util.Formatter;
import java.util.ArrayList;
public class Level implements IDrawable
{
    private static double timeEnd; // temps restant pour le niveau
    private static int level; 
    private static int nbSpaceManInit; //nombre d'astronaute en debut de partie
    private static int nbSpaceManCurrent; //nombre d'astronaute courrant
    private static int score; 
    
    public Level(ArrayList<Astronaut> arrayAstronaut)
    {
        timeEnd = Config.getSpaceManLvlTimeInt();
        level = 0;
        nbSpaceManInit = Config.getSpaceManInit();
        nbSpaceManCurrent = Config.getSpaceManInit();
        score = 0;
        /* on ajout les astronautes */
        for(int i = 0; i < nbSpaceManCurrent; i++)
        {
            arrayAstronaut.add(new Astronaut());
        }
    }
    
    
    /**
     * @return le level courant.
     */
    public static int getLevelCurrent()
    {
        return level;
    }
    
    /**
     *  on incrmente toute les variables du level
     */
    public static void increaseLevel(ArrayList<Astronaut> arrayAstronaut)
    {
        nbSpaceManInit = Config.getSpaceManInit() + ((Config.getSpaceManLvlAdd() * level)) + 1; // on augmente le nombre d'astronaute 
        nbSpaceManCurrent = Config.getSpaceManInit() + (Config.getSpaceManLvlAdd() * level) + 1;
        level += 1;
        
        // On gagne un bonus vie et un bonus invulnerabilit
        Main.getGame().getArrayBonus().add(Bonus.generateBonus(0));
        Main.getGame().getArrayBonus().add(Bonus.generateBonus(3));
        // On ajoute de nouveaux astronautes
        for(int i = 0; i < nbSpaceManCurrent; i++)
        {
             arrayAstronaut.add(new Astronaut());
        }
        
        // on regarde si on depasse le temps du niveau de base + temps par niveau
        if(timeEnd - PlayTime.getTime() + Config.getSpaceManLvlTimeInt() > Config.getSpaceManLvlTimeInt() + level * Config.getSpaceManLvlTimeBonus())
        {
            // temps de fin de partie : temps du niveau de base + temps par niveau
            timeEnd = PlayTime.getTime() + Config.getSpaceManLvlTimeInt() + level * Config.getSpaceManLvlTimeBonus();
        }
        else
        {
            // temps de fin de partie : temps courent + le temps restant de la partie precedente + le temps d'un niveau
            timeEnd = PlayTime.getTime() + (timeEnd - PlayTime.getTime() + Config.getSpaceManLvlTimeInt());
        }
    }
    
    /**
     * Permet de mettre le level  jour
     */
    public void refresh(ArrayList<Astronaut> arrayAstronaut)
    {
        if(isTimeDead() && arrayAstronaut.size() != 0)
        {
            Engine.setGameOver(true);
            Display.clearIDrawable(5);
            Display.addIDrawable(GuiEvent.getGameOver(), 5);
        }
        else if(arrayAstronaut.size() == 0) // on regarde si on doit rajouter les astronaut
        {

            increaseLevel(arrayAstronaut);          
        }
    }
    
    
    /**
    * decrmente le nombre d'astronaute courrant
    */
    public void increaseNbSpaceManCurrent()
    {
        nbSpaceManCurrent -= 1;
    }
    
    /**
    * @return le nombre d'astronautes courrent.
    */
    public int getNbSpaceManCurrent()
    {
        return nbSpaceManCurrent;
    }
    
    /**
    * @return Si l'on a dpass le temps de jeu imparti pour rcuprer les astronautes
    */
    public boolean isTimeDead()
    {
        return getLeftTime() < 0;
    }
    /**
    * @return le temps restant pour une partie
    */
    public double getLeftTime()
    {
        return timeEnd - PlayTime.getTime();
    }
    
    /**
    * @return le temps restant formatt proprement pour l'affichage.
    */
    public String getLeftTimeString()
    {
        int heure =  (int) (getLeftTime() / (1000 * 60 * 60)) % 60;
        int minute =  (int) (getLeftTime() / (1000 * 60)) % 60;
        int seconde =  (int) (getLeftTime() / 1000) % 60;
        String output = ""; //le valeur de output
        if (heure > 0)
            output += heure + ":";
        if (minute < 10)
            output += "0" + minute;
        else
            output += minute;
        output += ":";
        if (seconde < 10)
            output += "0" + seconde;
        else
            output += seconde;
        return output;
    }
    
    /**
    * @return le niveau courant.
    */
    public String toString()
    {
        return ""+level;
    }
    
    
    /**
     * Mthode pour dessiner les info sur le niveau.
     */
    public void draw(Graphics g)
    {
        int fontSize= (int) (20 * Config.getFrameRate());
        g.setFont(new Font("Verdanna", Font.PLAIN, fontSize));
        g.setColor(Color.white);
        
        //on dessine la barre de progression dans le sauvetage des astronautes
        g.drawRect((int)((Config.getFrameX() -100)*Config.getFrameRate()), (int)((100 * Config.getFrameRate())),(int)( 50 * Config.getFrameRate()), (int)(10*Config.getFrameRate()));
        
        g.fillRect((int)((Config.getFrameX() -100)*Config.getFrameRate()), (int)(100 * Config.getFrameRate()),(int)((50/nbSpaceManInit) * (nbSpaceManInit - nbSpaceManCurrent) * Config.getFrameRate()),(int) (10 * Config.getFrameRate()));
        
        //on dessine la barre de progression du temps du niveau
        g.drawRect((int)((Config.getFrameX() -100)*Config.getFrameRate()), (int)((85 * Config.getFrameRate())),(int)( 50 * Config.getFrameRate()), (int)(10*Config.getFrameRate()));
        
        g.fillRect((int)((Config.getFrameX() -100)*Config.getFrameRate()), (int)(85 * Config.getFrameRate()), (int)(((getLeftTime()/(Config.getSpaceManLvlTimeInt() + Config.getSpaceManLvlTimeBonus() * level)) * 50)  * Config.getFrameRate()),(int) (10 * Config.getFrameRate()));
        
        Graphics2D g2d = (Graphics2D) g;
        
        //on dessine le temps qu'il reste.
        g2d.drawString(getLeftTimeString(), (int)((Config.getFrameX() -100)*Config.getFrameRate()), (int)((75 * Config.getFrameRate())));
        
        // on dessine le level dans lequel on se trouve
        g2d.drawString("Niveau " + level, (int)((Config.getFrameX() -100)*Config.getFrameRate()),  (int)((55 * Config.getFrameRate())));
        
        // on dessine le ratio pour les astronautes
        g2d.drawString((nbSpaceManInit - nbSpaceManCurrent) +"/"+nbSpaceManInit, (int)((Config.getFrameX() -100)*Config.getFrameRate()),  (int)((130 * Config.getFrameRate())));
        
        
    }
    
    public void setTimeEnd(double t)
    {
        if( (getLeftTime() + t) < (Config.getSpaceManLvlTimeInt() + (Config.getSpaceManLvlTimeBonus() * level)))
            timeEnd += t;
        else
            timeEnd =PlayTime.getTime()+ Config.getSpaceManLvlTimeInt() + Config.getSpaceManLvlTimeBonus() * level;
    }
    
}