package be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.game;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.listener.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.geom.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.gui.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.*;

import java.awt.geom.Point2D;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.geom.AffineTransform;
import java.awt.Image;
import java.awt.Graphics2D;
import javax.swing.JPanel;
import java.awt.Font;
public class Life implements IDrawable
{
    public static final double MAXLIFE = 100; //vie max
    private double printLife; //vie affiche
    private double realLife; // vie rel
    private final int DWITH = 120 , DHEIGTH = 120; // dcalage du quadrant par apport au coin inferieur droit
    private final double LIFEWINRATE = 0.02; // fixe le gain/la perte de vie max par seconde  20.
    private double tInvulnerable; // temps d'invulerabilit restant
    private static double timeLasteFlashing; // temps courant du flash
    private static final double TIMEFLASHING = 60; //temps max du flash

    public Life()
    {
        printLife = 100;
        realLife = 100;
        tInvulnerable = 0;
        timeLasteFlashing=0;
    }
    
    /**
    * Mets  jours la vie affiche
    */
    public void refresh()
    {
        if (printLife < realLife) 
        {
            printLife += LIFEWINRATE * Config.getRefresh();
        }
        else if (printLife > realLife + (LIFEWINRATE * Config.getRefresh())) 
        {
            printLife -= LIFEWINRATE * Config.getRefresh();
            timeLasteFlashing += Config.getRefresh(); 
        }
        if (printLife <= realLife + (LIFEWINRATE * Config.getRefresh()) && printLife >= 1)
        {
            //on arrte le clignotement
            timeLasteFlashing = 0;
        }
        if(timeLasteFlashing >= TIMEFLASHING )
        {
            timeLasteFlashing = 0;
        }
    }
    

    /**
    * Ajout de la vie au vaisseau.
    * @param l nombre de point de vie  rajouter.
    */
    public void increaseLife(double l)
    {
        if ( realLife + l >= MAXLIFE)
            realLife = MAXLIFE;
        else if ( realLife + l <= 0)
            realLife = 0;
        else
            realLife = realLife + l;  // modulo 100 pour ne pas avoir de dpacement de pv.
    }
    
    /**
    * @return si notre vie est infrieur  1.
    */
    public boolean isDead()
    {
        // arrondi infrieur pour eviter d'avoir une barre vide et pas de game over si on a  0.5 pv
        return Math.floor(printLife) <= 0;
    }
    
    /**
    *   @return les points de vie courant.
    */
    public String toString()
    {
        return ""+ printLife;
    }
    
    /**
    *   @return les points de vie courant.
    */
    public double getLife()
    {
        return printLife;
    }    
    
    /**
    *   @return la vie maximal.
    */
    public double getMaxLife()
    {
        return MAXLIFE;
    }        
    
    /**
    * @return la vie restante en entier (entre 0 et 100).
    */
    public int getPourcentLife()
    {
        return (int) Math.floor((printLife/MAXLIFE) * 100);
    }
    /**
    *
    */
    public double getPourcentInvulnerabe()
    {
        if (isInvulnerable())
        {
            return ((tInvulnerable - PlayTime.getTime()) / Config.getInvulnerableTime());
        }
        else
            return 0;
    }
    
    /**
    * @return si le vaiseau est invulnerable.
    */
    public boolean isInvulnerable()
    {
        return ((tInvulnerable - PlayTime.getTime()) > 0 );
    }
    
    /**
    * Dfinit un nouveau temps d'invulnrabilit* 
    * @param t un temps d'invulnerabilit
    */
    public void setInvulnerabilite(double t)
    {
        // on regarde si le bonus qu'on gagne nous fait gagner du temps par apport au temps d'invulnrabilit qu'on a peut tre dj 
        if (PlayTime.getTime() + t > tInvulnerable)
            tInvulnerable = PlayTime.getTime() + t;
        else
            tInvulnerable += t;

        // On regarde si on accumule pas 2 bonus d'affil.
        if ( tInvulnerable > PlayTime.getTime() + Config.getInvulnerableTime())
            tInvulnerable = PlayTime.getTime() + Config.getInvulnerableTime();
    }

    /**
     *  Permet de dessiner un cadre de vie
     */
    public void draw(Graphics g)
    {        
        
        //barre de vie
        
        /* Position de la barre, hauteur et largeur de celle si */
        Point2D.Double pBarre = new Point2D.Double(50, 100);
        double width = 80;
        double height = 10;
        g.setColor(Color.red);
        g.fillRect((int)(pBarre.getX() * Config.getFrameRate()), (int)(pBarre.getY() * Config.getFrameRate()), (int)( width * Config.getFrameRate()), (int)(height * Config.getFrameRate()));
        
        g.setColor(Color.green);
        g.fillRect((int)(pBarre.getX() * Config.getFrameRate()), (int)(pBarre.getY() * Config.getFrameRate()), (int)( width * (printLife/MAXLIFE) * Config.getFrameRate()), (int)(height * Config.getFrameRate()));
        
        Graphics2D g2d = (Graphics2D) g;
        
        /* On choisi la couleur de la barre de vie pour quel clignote en rouge si on perd de la vie */
        if(timeLasteFlashing > (TIMEFLASHING/3))
            g2d.setColor(Color.red);
        else
            g2d.setColor(Color.white);
        
        //Barre blanche semi transparente reprsentant l'invulnrabilit
        AffineTransform at = new AffineTransform();
        at.translate((int)(pBarre.getX() * Config.getFrameRate()), (int)(pBarre.getY() * Config.getFrameRate()));
        at.scale(width * getPourcentInvulnerabe() * Config.getFrameRate(), height * Config.getFrameRate());
        g2d.drawImage(Engine.images.transparentBlueSeedlings, at, null);

        //contour de la barre
        g.drawRect((int)(pBarre.getX() * Config.getFrameRate()), (int)(pBarre.getY() * Config.getFrameRate()), (int)( width * Config.getFrameRate()), (int)(height * Config.getFrameRate()));
        
        
        // affichage de la vie sous forme de texte
        int fontSize= (int) (20 * Config.getFrameRate());
        g.setFont(new Font("Verdanna", Font.PLAIN, fontSize));
        g2d.drawString("PV: "+ getPourcentLife() + "%", (int)(pBarre.getX() * Config.getFrameRate()), (int)((pBarre.getY()-10) * Config.getFrameRate()));

        
    }
    
}