package be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.game;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.listener.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.geom.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.gui.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.*;

import java.awt.Graphics;
import java.awt.Color;
import java.awt.Font;
import java.awt.geom.AffineTransform;
import java.awt.Image;
import java.awt.Graphics2D;
import javax.swing.JPanel;
import java.util.Formatter;
public class Scoring implements IDrawable
{
    public  int score = 0; // score du jeu
    public static final int SCORINGMAX = 7;// nombre de caractere maximum pour le score
    public static final int ASTEROIDGAINTIMELIMIT = 50000; //on ne gagne plus de point aprs 50 secondes.

    public Scoring()
    {
        score = 0;
    }
    
    /**
    * @return le score de la partie.
    */    
    public  int getScore()
    {
        return score;
    }
    
    /**
     * Ajoute le score lors de la dstruction d'asteroide (si son temps de vie est plus petit que ASTEROIDGAINTIMELIMIT).
     * @param t un double
     * @param radius un double
     */
    public void destructionAsteroid(double t, double radius)
    {
        //formule pour calculer le score lors de la destruction d'asteroid(si son temps de vie est plus petit que ASTEROIDGAINTIMELIMIT)
        if (t < ASTEROIDGAINTIMELIMIT)
            score += (int)( (10 - (t / ASTEROIDGAINTIMELIMIT))* (50 / radius) ); 

    }
    
    /**
     * Ajoute le score lors du sauvetage des astronautes
     */
    public void destructionAstronaut()
    {
        //formule pour calculer le score lors du sauvetage des astronautes
        score += (int)(100 * (Level.getLevelCurrent()+1));

    }
    
    /**
    * Incremente le score.
    */
    public void increase(double t)
    {
        score += t;
    }
    
    /**
    * @return le score en String
    */
    public String toString()
    {
        String zero = "";
        String stringScore = "" + score;
        while(zero.length() + stringScore.length() < 7) //on calcul le nombre de zero qu'on doit mettre devant le score
        {
            zero += "0";
        }
        return zero + score;
    }
    
    /**
    *   Permet de dssiner le score  l'cran
    */
    public void draw(Graphics g)
    {
        int fontSize = (int) (25 * Config.getFrameRate());
        g.setFont(new Font("Verdanna", Font.PLAIN, fontSize));
        g.setColor(Color.white);
        Graphics2D g2d = (Graphics2D) g;
        g2d.drawString(this.toString(), (int) (50 * Config.getFrameRate()), (int) ((Config.getFrameY() - 45) * Config.getFrameRate()) );
    }
}
