package be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.gui;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.geom.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.game.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.listener.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.*;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;
public class Display extends JPanel
{
    private JFrame jframe;
    
    /* Taille de bordure de fentre 
    3 taptes :
    mettre la taille de fentre  une taille de base
    calculer la taille des bordures
    mettre la fentre  la bonne taille
    */
    // valeur de bordure de base dans windows
    private static Point2D.Double borderSize = new Point2D.Double(6,47); 
    
    /* On cre une array list qui contiendra 6 LinkedList qui elles contiendront la liste des lments  afficher sur 6 niveaux de profondeur
        0 Le fond - le radar
        1 Les astroides - Bonus - Missiles - Astronautes
        2 Le vaisseau - le 2me fond en dgrad
        3 Les Missiles (une courte priode (quand ils sont proche du vaisseau pour avoir une belle sortie du canon)
          et les astronautes dtect par le radar
        4 La barre de vie, le temps, le score, l'chauffement du canon, l'avancement dans les niveaux
        5 Les evenements de la GUI : pause, game over, l'aide
    */
    private static ArrayList<LinkedList<IDrawable>> drawableLayer = new ArrayList<LinkedList<IDrawable>>(6); 

    public Display()
    {
        super();
        initIDrawable(); // on reinitialise les IDrawables
        
        // Cration de la JFrame dans laquelle on placera ce panel. 
        jframe = new JFrame();
        jframe.setTitle("Asterode");
        jframe.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        jframe.setResizable(false);
        setBackground(Color.black);
        setFrameSize(800, 640);
        
        /* Menu */
        JMenuBar menuBar = new JMenuBar();
        JMenu game = new JMenu("Partie");
        JMenu newGame = new JMenu("(n) Nouvelle partie");
        JMenuItem easy = new JMenuItem("Facile");
        JMenuItem normal = new JMenuItem("Moyenne");
        JMenuItem hard = new JMenuItem("Difficile");
        JMenuItem pause = new JMenuItem("(p) Pause");
        
        JMenu sizeFrame = new JMenu("Rsolution");
        JMenuItem r1100x880 = new JMenuItem("1100x880");
        JMenuItem r900x720 = new JMenuItem("900x720");
        JMenuItem r800x640 = new JMenuItem("800x640");
        JMenuItem r600x480 = new JMenuItem("600x480");
        JMenuItem r450x360 = new JMenuItem("450x360");
        
        JMenu ips = new JMenu("Rafraichissement");
        JMenuItem ips60 = new JMenuItem("60 IPS");
        JMenuItem ips50 = new JMenuItem("50 IPS");
        JMenuItem ips30 = new JMenuItem("30 IPS");

        JMenu  help = new JMenu("Aide");
        JMenuItem helpControl = new JMenuItem("Commandes");
        JMenuItem helpInterface = new JMenuItem("Interface");        
        JMenuItem helpGame = new JMenuItem("But du jeu");
        JMenuItem helpBonus = new JMenuItem("Bonus");
        
                
        //mettre le jeu en facile
        easy.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                clearIDrawable(5);
                Config.setDifficulti(0);
                Main.setGame(new Engine(Main.getDisplay().getWidth(), Main.getDisplay().getHeight()));
            }
        }); 
        
        // mettre le jeu en normal
        normal.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                clearIDrawable(5);
                Config.setDifficulti(1);
                Main.setGame( new Engine(Main.getDisplay().getWidth(), Main.getDisplay().getHeight()) );
            }
        });
        
        // mettre le jeu en difficile
        hard.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                clearIDrawable(5);
                Config.setDifficulti(2);
                Main.setGame( new Engine(Main.getDisplay().getWidth(), Main.getDisplay().getHeight()) );
            }
        });
        
         // mettre le jeu en pause/rsume
        pause.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                Engine.changeBreackGame();
            }
        });
        
         // mettre le jeu en 1100x880
        r1100x880.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                setFrameSize(1100, 880);
            }
        });
        
         // mettre le jeu en 900x720
        r900x720.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                setFrameSize(900, 720);
            }
        });  
        
         // mettre le jeu en 800x640
        r800x640.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                setFrameSize(800, 640);
            }
        });
        
        // mettre le jeu en 600x480
        r600x480.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                setFrameSize(600, 480);
            }
        });
        
        // mettre le jeu en 450x360
        r450x360.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                setFrameSize(450, 360);
            }
        });
        
        // affiche l'aide pour le controle des touches
        helpControl.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                Engine.SetBreackGame();
                clearIDrawable(5);
                addIDrawable(GuiEvent.getHelpControl(), 5);
            }
        });
        
        // affiche l'aide pour l'interface
        helpInterface.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                Engine.SetBreackGame();
                clearIDrawable(5);
                addIDrawable(GuiEvent.getHelpInterface(), 5);  
            }
        });
        
        // affiche l'aide pour les bonus
        helpBonus.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                Engine.SetBreackGame();
                clearIDrawable(5);
                addIDrawable(GuiEvent.getHelpBonus(), 5);
            }
        });        
        
        // affiche l'aide pour le but du jeu
        helpGame.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                Engine.SetBreackGame();
                clearIDrawable(5);
                addIDrawable(GuiEvent.getHelpGame(), 5);
            }
        });        
        
        // modofie le temps entre les repaint
        ips60.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                Main.setTRepaint(16L);
            }
        });    
        
        // modofie le temps entre les repaint
        ips50.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                Main.setTRepaint(20L);
            }
        });    
        
        // modofie le temps entre les repaint
        ips30.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                Main.setTRepaint(33L);
            }
        });
        
        
        game.add(newGame);
        game.add(pause);
        newGame.add(easy);
        newGame.add(normal);
        newGame.add(hard);
        sizeFrame.add(r450x360);
        sizeFrame.add(r600x480);
        sizeFrame.add(r800x640);
        sizeFrame.add(r900x720);
        sizeFrame.add(r1100x880);
        ips.add(ips60);
        ips.add(ips50);
        ips.add(ips30);
        help.add(helpControl);
        help.add(helpInterface);
        help.add(helpBonus);
        help.add(helpGame);
        menuBar.add(game);
        menuBar.add(sizeFrame);
        menuBar.add(ips);
        menuBar.add(help);
        jframe.setJMenuBar(menuBar);
        
        /* FIN menu */
        
        // on ajoute le fond de debut
        addIDrawable(GuiEvent.getNewGame(), 5);
        
        /* Pour viter tout scintillement on active le double tampon sur le panel et on demande d'ignorer les repaints l'hors de l'affichage*/
        this.setDoubleBuffered(true);
        this.setIgnoreRepaint(true);
        jframe.setLocationRelativeTo(null); // centre la fentre
        jframe.getContentPane().add(this);

        
        jframe.setVisible(true);
        setSizeBorder();
        setFrameSize(800, 640);

        // on ajoute le gestionnaire de touche et de souris
        jframe.addKeyListener(new Key());
        jframe.addMouseListener(new MouseKey());
        jframe.addMouseMotionListener(new MouseMotion());
    }
    
    @Override
    public void paint(Graphics g)
    {
        /* On dessine un rectangle noir pour ffacer les anciens lments. */
        GuiEvent.drawBackgroundBlack(g);

        /* On va parcourir tout les lments des layers et les afficher */
        // On synchronise l'affichage avec l'ajout et suppression dans la liste 
        synchronized (drawableLayer)
        {
            for (LinkedList<IDrawable> layer : drawableLayer)
            {   
                for (IDrawable element : layer)
                {
                    element.draw(g);
                }
            }    
        }
    }
    

    
    /**
    * Permet d'ajouter un lment  pour l'affichage dans une des couches.
    * @param l un entier designant la hauteur de la couche o l'on ajoute l'lment.
    */
    public static void addIDrawable(IDrawable d, int l) 
    {
        synchronized (drawableLayer)
        {
            drawableLayer.get(l).addLast(d);
        }
    }
    
    /**
    * Permet de supprimer un lment  pour l'affichage dans une des couches.
    * @param l un entier designant la hauteur de la couche o l'on ajoute l'lment.
    */
    public static void removeIDrawable(IDrawable d, int l) 
    {
        synchronized (drawableLayer)
        {
            drawableLayer.get(l).remove(d);
        }
    } 
    
    /**
    * Vide une de couche pour l'affichage.
    * @param l un entier designant la hauteur de la couche o l'on ajoute l'lment.
    */
    public static void clearIDrawable(int l) 
    {
        synchronized (drawableLayer)
        {
            drawableLayer.get(l).clear();
        }
    }  
    
    /**
    * Rinitialise les couches du layer
    */
    public static void initIDrawable()
    {
        synchronized (drawableLayer)
        {
            drawableLayer = new ArrayList<LinkedList<IDrawable>>(6);  // rinitialise l'affichage
            for (int i = 0; i < 6; i++)
            {
                drawableLayer.add(new LinkedList<IDrawable>());
            }
        }
    }

    /**
    * Fermeture de la fentre
    */
    public void close()
    {
        jframe.dispose(); // libre les accs mmoire.
    }
    
    /**
    * Change la taille de la fentre
    * @param width Largeur de la fentre.
    * @param height Hauteur de la fentre.
    */
    public void setFrameSize(int width, int height)
    {
        jframe.setSize(new Dimension((int) (width + borderSize.getX()), (int) (height + borderSize.getY())));
        Config.setFrame(width, height);
    }
    
    /**
    * Calcule la taille de la bordure de la fentre.
    * Prrequis : que la fentre soit en visible.
    */
    public void setSizeBorder()
    {
        //On fait la diffrence entre la taille de la fentre et la taille de l'interieur de la fentre
        double borderX = jframe.getWidth() - jframe.getContentPane().getWidth();
        double borderY = jframe.getHeight() - jframe.getContentPane().getHeight();
        borderSize = new Point2D.Double(borderX, borderY);
    }
    
    /**
    * @return la largeur et hauteur de la bordure de la fentre.
    */
    public static Point2D.Double getBorderSize()
    {
        return borderSize;
    }
}